3 # Copyright (c) 2005, 2006 Junio C Hamano
7 git-am [options] <mbox>|<Maildir>...
8 git-am [options] --resolved
9 git-am [options] --skip
11 d,dotest= use <dir> and not .dotest
12 i,interactive run interactively
13 b,binary pass --allo-binary-replacement to git-apply
14 3,3way allow fall back on 3way merging if needed
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flagg to git-mailinfo
18 whitespace= pass it through git-apply
19 C= pass it through git-apply
20 p= pass it through git-apply
21 resolvemsg= override error message when patch failure occurs
22 r,resolved to be used after a patch failure
23 skip skip the current patch"
29 git var GIT_COMMITTER_IDENT >/dev/null || exit
32 echo "$1" >"$dotest/next"
36 stop_here_user_resolve () {
37 if [ -n "$resolvemsg" ]; then
38 printf '%s\n' "$resolvemsg"
41 cmdline=$(basename $0)
42 if test '' != "$interactive"
46 if test '' != "$threeway"
50 if test '.dotest' != "$dotest"
52 cmdline="$cmdline -d=$dotest"
54 echo "When you have resolved this problem run \"$cmdline --resolved\"."
55 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
61 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
62 "$dotest/patch" "$dotest/info"
63 echo "$next" >"$dotest/next"
69 echo "Cannot fall back to three-way merge."
74 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
76 rm -fr "$dotest"/patch-merge-*
77 mkdir "$dotest/patch-merge-tmp-dir"
79 # First see if the patch records the index info that we can use.
80 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
82 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
83 git write-tree >"$dotest/patch-merge-base+" ||
84 cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
86 echo Using index info to reconstruct a base tree...
87 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
88 git apply $binary --cached <"$dotest/patch"
90 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
91 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
93 cannot_fallback "Did you hand edit your patch?
94 It does not apply to blobs recorded in its index."
97 test -f "$dotest/patch-merge-index" &&
98 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
99 orig_tree=$(cat "$dotest/patch-merge-base") &&
100 rm -fr "$dotest"/patch-merge-* || exit 1
102 echo Falling back to patching base and 3-way merge...
104 # This is not so wrong. Depending on which base we picked,
105 # orig_tree may be wildly different from ours, but his_tree
106 # has the same set of wildly different changes in parts the
107 # patch did not touch, so recursive ends up canceling them,
108 # saying that we reverted all those changes.
110 eval GITHEAD_$his_tree='"$SUBJECT"'
111 export GITHEAD_$his_tree
112 git-merge-recursive $orig_tree -- HEAD $his_tree || {
114 echo Failed to merge in the changes.
117 unset GITHEAD_$his_tree
121 git stripspace <"$1" | sed -e 1q
125 dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
141 utf8=t ;; # this is now default
153 shift; resolvemsg=$1 ;;
155 git_apply_opt="$git_apply_opt $1=$2"; shift ;;
157 git_apply_opt="$git_apply_opt $1$2"; shift ;;
166 # If the dotest directory exists, but we have finished applying all the
167 # patches in them, clear it out.
168 if test -d "$dotest" &&
169 last=$(cat "$dotest/last") &&
170 next=$(cat "$dotest/next") &&
172 test "$next" -gt "$last"
179 case "$#,$skip$resolved" in
181 # Explicit resume command and we do not have file, so
185 # No file input but without resume parameters; catch
186 # user error to feed us a patch from standard input
187 # when there is already .dotest. This is somewhat
188 # unreliable -- stdin could be /dev/null for example
189 # and the caller did not intend to feed us a patch but
190 # wanted to continue unattended.
197 die "previous dotest directory $dotest still exists but mbox given."
200 # Make sure we are not given --skip nor --resolved
201 test ",$skip,$resolved," = ,,, ||
202 die "Resolve operation not in progress, we are not resuming."
205 mkdir -p "$dotest" || exit
207 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
212 # -b, -s, -u, -k and --whitespace flags are kept for the
213 # resuming session after a patch failure.
214 # -3 and -i can and must be given when resuming.
215 echo "$binary" >"$dotest/binary"
216 echo " $ws" >"$dotest/whitespace"
217 echo "$sign" >"$dotest/sign"
218 echo "$utf8" >"$dotest/utf8"
219 echo "$keep" >"$dotest/keep"
220 echo 1 >"$dotest/next"
225 files=$(git diff-index --cached --name-only HEAD --) || exit
226 if [ "$files" ]; then
227 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
232 if test "$(cat "$dotest/binary")" = t
234 binary=--allow-binary-replacement
236 if test "$(cat "$dotest/utf8")" = t
242 if test "$(cat "$dotest/keep")" = t
246 ws=`cat "$dotest/whitespace"`
247 if test "$(cat "$dotest/sign")" = t
249 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
251 s/^/Signed-off-by: /'
257 last=`cat "$dotest/last"`
258 this=`cat "$dotest/next"`
262 this=`expr "$this" + 1`
266 if test "$this" -gt "$last"
273 while test "$this" -le "$last"
275 msgnum=`printf "%0${prec}d" $this`
276 next=`expr "$this" + 1`
277 test -f "$dotest/$msgnum" || {
283 # If we are not resuming, parse and extract the patch information
284 # into separate files:
285 # - info records the authorship and title
286 # - msg is the rest of commit log message
287 # - patch is the patch body.
289 # When we are resuming, these files are either already prepared
290 # by the user, or the user can tell us to do so by --resolved flag.
293 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
294 <"$dotest/$msgnum" >"$dotest/info" ||
297 # skip pine's internal folder data
298 grep '^Author: Mail System Internal Data$' \
299 <"$dotest"/info >/dev/null &&
302 test -s $dotest/patch || {
303 echo "Patch is empty. Was it split wrong?"
306 git stripspace < "$dotest/msg" > "$dotest/msg-clean"
310 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
311 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
312 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
314 if test -z "$GIT_AUTHOR_EMAIL"
316 echo "Patch does not have a valid e-mail address."
320 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
322 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
323 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
327 if test '' != "$SIGNOFF"
330 sed -ne '/^Signed-off-by: /p' \
331 "$dotest/msg-clean" |
335 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
336 test '' = "$LAST_SIGNED_OFF_BY" && echo
343 printf '%s\n' "$SUBJECT"
344 if test -s "$dotest/msg-clean"
347 cat "$dotest/msg-clean"
349 if test '' != "$ADD_SIGNOFF"
353 } >"$dotest/final-commit"
356 case "$resolved$interactive" in
358 # This is used only for interactive view option.
359 git diff-index -p --cached HEAD -- >"$dotest/patch"
365 if test "$interactive" = t
368 die "cannot be interactive without stdin connected to a terminal."
370 while test "$action" = again
372 echo "Commit Body is:"
373 echo "--------------------------"
374 cat "$dotest/final-commit"
375 echo "--------------------------"
376 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
380 [aA]*) action=yes interactive= ;;
381 [nN]*) action=skip ;;
382 [eE]*) git_editor "$dotest/final-commit"
383 SUBJECT=$(reread_subject "$dotest/final-commit")
386 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
394 if test $action = skip
400 if test -x "$GIT_DIR"/hooks/applypatch-msg
402 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
406 printf 'Applying %s\n' "$SUBJECT"
410 git apply $git_apply_opt $binary --index "$dotest/patch"
414 # Resolved means the user did all the hard work, and
415 # we do not have to do any patch application. Just
416 # trust what the user has in the index file and the
419 git diff-index --quiet --cached HEAD -- && {
420 echo "No changes - did you forget to use 'git add'?"
421 stop_here_user_resolve $this
423 unmerged=$(git ls-files -u)
424 if test -n "$unmerged"
426 echo "You still have unmerged paths in your index"
427 echo "did you forget to use 'git add'?"
428 stop_here_user_resolve $this
435 if test $apply_status = 1 && test "$threeway" = t
439 # Applying the patch to an earlier tree and merging the
440 # result may have produced the same tree as ours.
441 git diff-index --quiet --cached HEAD -- && {
442 echo No changes -- Patch already applied.
446 # clear apply_status -- we have successfully merged.
450 if test $apply_status != 0
452 echo Patch failed at $msgnum.
453 stop_here_user_resolve $this
456 if test -x "$GIT_DIR"/hooks/pre-applypatch
458 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
461 tree=$(git write-tree) &&
462 parent=$(git rev-parse --verify HEAD) &&
463 commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
464 git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
467 if test -x "$GIT_DIR"/hooks/post-applypatch
469 "$GIT_DIR"/hooks/post-applypatch